/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Send Page by Email (spbeOptions.js).
 *
 * The Initial Developer of the Original Code is Weidong Lu.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Weidong Lu <lwd.firefox@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function spbe_initOptions(){

	sizeToContent();
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");

    document.getElementById("spbe_sourceEmail").value = spbeOptions.getCharPref("opt_sourceEmail");
    document.getElementById("spbe_smtpServer").value = spbeOptions.getCharPref("opt_smtpServer");
    document.getElementById("spbe_portNumber").value = spbeOptions.getIntPref("opt_portNumber");
    document.getElementById("spbe_smtpUser").value = spbeOptions.getCharPref("opt_smtpUser");

	spbe_listBoxInit(document.getElementById("spbe_emailListBox"), spbeOptions.getCharPref("opt_emailList"));
	spbe_listBoxInit(document.getElementById("spbe_labelListBox"), spbeOptions.getCharPref("opt_labelList"));
	spbe_listBoxInit(document.getElementById("spbe_wordListBox"), spbeOptions.getCharPref("opt_wordList"));

	var charsetValue = spbeOptions.getCharPref("opt_charset");
	var charsetIndex = spbeOptions.getIntPref("opt_charsetIndex");
	if (charsetIndex == -1) {
		document.getElementById("spbe_charset").value = charsetValue;
	}
	else  document.getElementById("spbe_charset").selectedIndex = charsetIndex;
	// new added option value is always put at last place in order not to unset existing values.
    document.getElementById("spbe_replyToEmail").value = spbeOptions.getCharPref("opt_replyToEmail");
	document.getElementById("spbe_mailsendPath").value = spbeOptions.getCharPref("opt_mailsendPath");
	document.getElementById("spbe_thunderbirdPath").value = spbeOptions.getCharPref("opt_thunderbirdPath");
	document.getElementById("spbe_seaMonkeyPath").value = spbeOptions.getCharPref("opt_seaMonkeyPath");
	document.getElementById("spbe_sendEmailPath").value = spbeOptions.getCharPref("opt_sendEmailPath");

	if (spbeOptions.getIntPref("opt_defaultEmailProgram") != -1) {
			var defaultEmailProgramIndex = spbeOptions.getIntPref("opt_defaultEmailProgram");
			var emailProgram = ["mailsend", "Thunderbird", "SeaMonkey", "sendEmail"];
			document.getElementById("spbe_emailProgramListBox").getItemAtIndex(defaultEmailProgramIndex).firstChild.setAttribute("label", emailProgram[defaultEmailProgramIndex]+"**"); //put ** to the default Email program 
			document.getElementById("spbe_defaultEmailProgram").value = defaultEmailProgramIndex;
	}

	document.getElementById("spbe_alwaysDefaultEncoding").checked = spbeOptions.getIntPref("opt_alwaysDefaultEncoding");
	document.getElementById("spbe_multipleAccounts").checked = spbeOptions.getIntPref("opt_multipleAccounts"); 
	if (spbeOptions.getIntPref("opt_multipleAccounts") == 1) {
		for (var i = 1; i < 6; i++)
			document.getElementById("spbe_multipleAcc"+i).disabled = false; // enable all the buttons
	}

	document.getElementById("spbe_directThunderbird").checked = spbeOptions.getIntPref("opt_directThunderbird");
	document.getElementById("spbe_selectedContentEdit").checked = spbeOptions.getIntPref("opt_selectedContentEdit");
	document.getElementById("spbe_askWeblink").checked = spbeOptions.getIntPref("opt_askWeblink");
	document.getElementById("spbe_includeWeblinkRadioGroup").selectedIndex = spbeOptions.getIntPref("opt_includeWeblinkRadioGroup");
	spbe_listBoxInit(document.getElementById("spbe_emailAccountsListBox"), spbeOptions.getCharPref("opt_emailAccountsList"));
}

function spbe_saveOptions(){

    var sourceEmail = document.getElementById("spbe_sourceEmail").value;
	var replyToEmail = document.getElementById("spbe_replyToEmail").value;
	var smtpServer = document.getElementById("spbe_smtpServer").value;
	var portNumber = document.getElementById("spbe_portNumber").value;

	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");	
			spbeOptions.setCharPref("opt_sourceEmail", sourceEmail);
			spbeOptions.setCharPref("opt_smtpServer", smtpServer);
			spbeOptions.setCharPref("opt_replyToEmail", replyToEmail);	
			spbeOptions.setIntPref("opt_portNumber", portNumber);
			spbeOptions.setCharPref("opt_smtpUser", document.getElementById("spbe_smtpUser").value);
			spbeOptions.setCharPref("opt_emailList", spbe_listBoxToString(document.getElementById("spbe_emailListBox")));
			spbeOptions.setCharPref("opt_labelList", spbe_listBoxToString(document.getElementById("spbe_labelListBox")));
			spbeOptions.setCharPref("opt_charset", document.getElementById("spbe_charset").value.toUpperCase());
			spbeOptions.setIntPref("opt_charsetIndex", document.getElementById("spbe_charset").selectedIndex);
			spbeOptions.setCharPref("opt_wordList", spbe_listBoxToString(document.getElementById("spbe_wordListBox")));
			spbeOptions.setCharPref("opt_mailsendPath", document.getElementById("spbe_mailsendPath").value);
			spbeOptions.setCharPref("opt_thunderbirdPath", document.getElementById("spbe_thunderbirdPath").value);
			spbeOptions.setCharPref("opt_seaMonkeyPath", document.getElementById("spbe_seaMonkeyPath").value);
			spbeOptions.setCharPref("opt_sendEmailPath", document.getElementById("spbe_sendEmailPath").value);
			spbeOptions.setIntPref("opt_alwaysDefaultEncoding", document.getElementById("spbe_alwaysDefaultEncoding").checked);
			spbeOptions.setIntPref("opt_multipleAccounts", document.getElementById("spbe_multipleAccounts").checked);
			
			spbeOptions.setIntPref("opt_directThunderbird", document.getElementById("spbe_directThunderbird").checked);
			spbeOptions.setIntPref("opt_askWeblink", document.getElementById("spbe_askWeblink").checked);
			spbeOptions.setIntPref("opt_selectedContentEdit", document.getElementById("spbe_selectedContentEdit").checked);
			if (document.getElementById("spbe_includeWeblinkRadioGroup").selectedIndex != 1) 
				spbeOptions.setIntPref("opt_includeWeblinkRadioGroup", 0);
			else
				spbeOptions.setIntPref("opt_includeWeblinkRadioGroup", 1);

			if (document.getElementById("spbe_defaultEmailProgram").value == "") {
				alert("Please specify the path to at least one email program by pressing the 'Locate email programs...' button.");
				window.openDialog('chrome://sendpagebyemail/content/spbeOptions.xul', 'Options', 'chrome, resizable=yes');
			} else spbeOptions.setIntPref("opt_defaultEmailProgram", document.getElementById("spbe_defaultEmailProgram").value);
			spbeOptions.setCharPref("opt_emailAccountsList", spbe_listBoxToString(document.getElementById("spbe_emailAccountsListBox")));
}

function spbe_listBoxInit( listBox, listString ){
	var convUnicode = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	convUnicode.charset = "UTF-8";

	if (listString != "") {
		var stringArray = listString.split("|");		
		for (var n = 0; n < stringArray.length; n++) {
			var str = convUnicode.ConvertToUnicode(stringArray[n]);
			listBox.appendItem(str, str);
		}
	}

}

/* function excuted when add or delete buttons are clicked*/
function spbe_addItem( listBox, spbe_element){
	
	var spbe_item = spbe_element.value;
	if (!spbe_listBoxHasItem(spbe_item, listBox)) {
		listBox.appendItem(spbe_item, spbe_item);
		spbe_element.value = "";
	}
	else 
		alert("This value already exists in the list.");
}

function spbe_addEmailAccountItem(){
	var emailAccountListBox = document.getElementById("spbe_emailAccountsListBox");
	var accountInfo = document.getElementById("spbe_sourceEmail").value + "&"
		+ document.getElementById("spbe_replyToEmail").value + "&"
		+ document.getElementById("spbe_smtpServer").value + "&"
		+ document.getElementById("spbe_portNumber").value + "&"
		+ document.getElementById("spbe_smtpUser").value;
	
	emailAccountListBox.appendItem(accountInfo, accountInfo);
}

function spbe_editEmailAccount(){
	var emailAccountListBox = document.getElementById("spbe_emailAccountsListBox");
	var accountInfo = emailAccountListBox.selectedItem.value;
	var accountInfoArray = accountInfo.split("&");
	
	document.getElementById("spbe_sourceEmail").value = accountInfoArray[0];
    document.getElementById("spbe_replyToEmail").value = accountInfoArray[1];
	document.getElementById("spbe_smtpServer").value = accountInfoArray[2];
	document.getElementById("spbe_portNumber").value = accountInfoArray[3];
	document.getElementById("spbe_smtpUser").value = accountInfoArray[4];
} 

function spbe_listBoxHasItem(listItemValue, listBox){
	
	var hasItem = false;
	var rowCount = listBox.getRowCount();
	if (rowCount > 0){
		for (var i = 0; i < rowCount; i++){
			if (listItemValue == listBox.getItemAtIndex(i).value) {
				hasItem = true;
				break;
			}
		}
	}
	return hasItem;
}

function spbe_delItem( listBox){
	var indexToBeRemoved = new Array();

	if (confirm("The item(s) you selected will be deleted, confirm?")){
		if (listBox.selectedCount == 1) {

			var selectedindex = listBox.selectedIndex;
			listBox.removeItemAt(selectedindex);        
		} else 
			if (listBox.selectedCount > 1) {
				var selectedItems = listBox.selectedItems;
				for (i = 0; i < selectedItems.length; i++){
					indexToBeRemoved[i] = listBox.getIndexOfItem(selectedItems[i]);
				}
				for (j = 0; j < indexToBeRemoved.length; j++)
					listBox.removeItemAt(indexToBeRemoved[j]-j);
			}
	}

}

function spbe_itemUp( listBox){
	var selectedIndex = listBox.selectedIndex;
	var selectedText = listBox.selectedItem.value;
	listBox.insertItemAt(selectedIndex-1, selectedText, selectedText);
	listBox.removeItemAt(selectedIndex+1);
	listBox.selectedIndex = selectedIndex - 1;
}

function spbe_itemDown( listBox){
	var selectedIndex = listBox.selectedIndex;
	var selItem = listBox.selectedItem;
	if (selectedIndex < (listBox.getRowCount() - 2)){
		listBox.insertItemAt(selectedIndex+2, selItem.value, selItem.value);
		listBox.removeItemAt(selectedIndex);
		listBox.selectedIndex = selectedIndex + 1;
	}
	else {
		var lastItem = listBox.getNextItem(selItem, 1);
		var lastItemValue = lastItem.value;
		lastItem.label = selItem.value;
		lastItem.value = selItem.value;
		selItem.label = lastItemValue;
		selItem.value = lastItemValue;
		listBox.selectedIndex = selectedIndex + 1;
	}
}

function spbe_importEmails(listBox){

	var emailAddress;
	/*Read Options Email List*/
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");
	var emailList = spbeOptions.getCharPref("opt_emailList");

	/*Read input string from a file*/
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, null, nsIFilePicker.modeOpen);

	fp.appendFilters(nsIFilePicker.filterAll);
	var result = fp.show();
	if (result == nsIFilePicker.returnOK) {
		var emailFile = Components.classes["@mozilla.org/network/file-input-stream;1"].
            createInstance(Components.interfaces.nsIFileInputStream);
		emailFile.init(fp.file, 0x01, 0444,0);//0x01:PR_RDONLY ReadOnly; 0444 read permission to all
		emailFile.QueryInterface(Components.interfaces.nsILineInputStream);

		var line={}, hasmore;
		do {
			hasmore = emailFile.readLine(line);
			emailAddress = line.value.match(/(\w+|\.|-)+@(\w+|\.|-)+/);//parse email address in a line
			if ((emailAddress != null) && (emailList.indexOf(emailAddress[0]) == -1))
				listBox.appendItem(emailAddress[0], emailAddress[0]);
		}while (hasmore);

		emailFile.close();
	}
}

function spbe_listBoxToString(listBox){
 
	var listBoxString = "";
	var rowCount = listBox.getRowCount();
	var convUnicode = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	convUnicode.charset = "UTF-8";
	
	if (rowCount > 0) {
		for (var i = 0; i < (rowCount-1); i++) {
			var str = convUnicode.ConvertFromUnicode(listBox.getItemAtIndex(i).value) + convUnicode.Finish();
			listBoxString = listBoxString + str + "|";
		}
		listBoxString = listBoxString + convUnicode.ConvertFromUnicode(listBox.getItemAtIndex(i).value) + convUnicode.Finish();
	} 
	return listBoxString;
}

function spbe_exportLabels(listBox){
	var listBoxString = spbe_listBoxToString(listBox);

	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, null, nsIFilePicker.modeSave);
	fp.appendFilters(nsIFilePicker.filterText);
	var result = fp.show();
	if (result == nsIFilePicker.returnOK) {
		var listboxFile = Components.classes["@mozilla.org/network/file-output-stream;1"].
            createInstance(Components.interfaces.nsIFileOutputStream);
		listboxFile.init(fp.file, 0x02 | 0x08 | 0x20, 0666, 0);
		//see example on mozilla developer centre about NSiFileOutputStream
		listboxFile.write(listBoxString, listBoxString.length);
		listboxFile.close();
	}
}

function spbe_importLabels(listBox){

	var labels={};
	/*Read input string from a file*/
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, null, nsIFilePicker.modeOpen);

	fp.appendFilters(nsIFilePicker.filterAll);
	var result = fp.show();
	if (result == nsIFilePicker.returnOK) {
		var listboxFile = Components.classes["@mozilla.org/network/file-input-stream;1"].
            createInstance(Components.interfaces.nsIFileInputStream);

		listboxFile.init(fp.file, 0x01, 0444,0);//0x01:PR_RDONLY ReadOnly; 0444 read permission to all
		listboxFile.QueryInterface(Components.interfaces.nsILineInputStream);
		listboxFile.readLine(labels);
		listboxFile.close();
	}

	// write to lables listbox
	if (labels.value != "") {
		var stringArray = labels.value.split("|");

		for (var n = 0; n < stringArray.length; n++){
			if (!spbe_listBoxHasItem(stringArray[n], listBox)) listBox.appendItem(stringArray[n], stringArray[n]);
		}
	} else alert("This file is empty!");
}

function spbe_locateEmailProgram(){
	var firstDefault;
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, null, nsIFilePicker.modeOpen);

	fp.appendFilters(nsIFilePicker.filterApps);
	var result = fp.show();
	if (result == nsIFilePicker.returnOK) {
		var emailProgramPath = fp.file.path;
		if (emailProgramPath.indexOf("mailsend") != -1) {
			document.getElementById("spbe_mailsendPath").value = emailProgramPath;
			firstDefault = 0;
		}
		else if (emailProgramPath.indexOf("thunderbird") != -1) {
			document.getElementById("spbe_thunderbirdPath").value = emailProgramPath;
			firstDefault = 1;
		}
		else if (emailProgramPath.indexOf("seamonkey") != -1) {
			document.getElementById("spbe_seaMonkeyPath").value = emailProgramPath;
			firstDefault = 2;
		}
		else if (emailProgramPath.indexOf("sendEmail") != -1) {
			document.getElementById("spbe_sendEmailPath").value = emailProgramPath;
			firstDefault = 3;
		}
		else alert("The name of the email program must contain one of these four words: \nmailsend, thunderbird, seamonkey, or sendEmail.");
	}
	if (document.getElementById("spbe_defaultEmailProgram").value == "") document.getElementById("spbe_defaultEmailProgram").value = firstDefault;
}

function spbe_setDefaultEmailProgram(){
	var emailProgram = ["mailsend", "Thunderbird", "SeaMonkey", "sendEmail"];
	var emailProgramListbox = document.getElementById("spbe_emailProgramListBox");
	var selectedProgramIndex = emailProgramListbox.selectedIndex; 
   
	if (selectedProgramIndex == -1) alert("Please select an email program in the 'supported email programs' list above.");
	else {
	    // remove ** from previous selected default program by rewrite every label to its orginal.
		var selectedProgram = document.getElementById("spbe_emailProgramListBox").selectedItem;
		for (var i = 0; i < 4; i++)
			emailProgramListbox.getItemAtIndex(i).firstChild.setAttribute("label", emailProgram[i]);
		
		selectedProgram.firstChild.setAttribute("label", emailProgram[selectedProgramIndex]+"**");
		document.getElementById("spbe_defaultEmailProgram").value = emailProgramListbox.selectedIndex;
	}

	// alert when command line email program is set as default
	if (((selectedProgramIndex == 0) || (selectedProgramIndex == 3)) && (document.getElementById("spbe_sourceEmail").indexOf("@") != -1))  {
		alert("You have selected a command line email program. \nPlease fill in the 'command line email program settings' in the 'Email accounts' Tab. \nOtherwise, you can not send out any email.");
		document.getElementById("spbe_optionTabs").selectedIndex = 1; // show the "Email accounts" tab
	}
}

function spbe_invokeThunderbirdDirectly(){//used in the option of invoking thunderbird without showing dialog window

	if (document.getElementById("spbe_directThunderbird").checked == true){
		var defaultEmailProgram = document.getElementById("spbe_defaultEmailProgram");
		if (defaultEmailProgram.value == "") {
			alert("Please set the default email program first.");
			document.getElementById("spbe_directThunderbird").checked = false;
		}

		else if ((defaultEmailProgram.value == 0) ||  (defaultEmailProgram.value == 3)){
			alert("You have to set the default email program to Thunderbird or SeaMonkey first \nin the 'Email Settings' tab.");
			document.getElementById("spbe_directThunderbird").checked = false;
			document.getElementById("spbe_optionTabs").selectedIndex = 0; // show the "Email Setup" tab
		}
		else alert("Warning: by doing so, you will not be able to use the advanced features provided by 'Send page by email', for example: \n\n1. Attaching images on the webpage. \n2. Adding labels/tags to the subject for email categorization.");
	}
}

function spbe_useGmailSMTP(){
	
	var gmailCheck = document.getElementById("spbe_useGmailSMTP");

		document.getElementById("spbe_sourceEmail").value = "#YOUREMAIL#@gmail.com";
		document.getElementById("spbe_smtpServer").value = "smtp.gmail.com";
		document.getElementById("spbe_portNumber").value = 587;
		document.getElementById("spbe_smtpUser").value = "#YOUREMAIL#";
		alert("Please replace '#YOUREMAIL#' with your real gmail account name.\nFor example, if your email address is JohnSmith@gmail.com, replace #YOUREMAIL# with JohnSmith at both 'Your email address' and 'SMTP user name' fields.");

}

function spbe_useMultipleAccounts(){
	var multipleAccCheck = document.getElementById("spbe_multipleAccounts");
	var i;

	if (multipleAccCheck.checked == false) {
		for (i = 1; i < 6;i++)
			document.getElementById("spbe_multipleAcc"+i).disabled = true;
		// use the first item as default email account and put the value back to the fields.
		var accountInfo = document.getElementById("spbe_emailAccountsListBox").getItemAtIndex(0).value.split("&");
		document.getElementById("spbe_sourceEmail").value = accountInfo[0];
		document.getElementById("spbe_replyToEmail").value = accountInfo[1];
		document.getElementById("spbe_smtpServer").value = accountInfo[2];
		document.getElementById("spbe_portNumber").value = accountInfo[3];
		document.getElementById("spbe_smtpUser").value = accountInfo[4];
		
	} else if (multipleAccCheck.checked == true){
		alert("To add an account to the list: \nFill in the fields in the 'command line email settings' box above and press 'Add' button. \n\nTo edit an account in the list: \nSelect the account and press 'Edit' button. \nThe email account info will show in the 'command line email settings' box above.");

		for (i = 1; i < 6;i++)
			document.getElementById("spbe_multipleAcc"+i).disabled = false;
	}
}
